
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TasksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tasks = await db.tasks.create(
            {
                id: data.id || undefined,
        
        external_task_key: data.external_task_key
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        task_status: data.task_status
        ||
        null
            ,
            
        created_at_remote: data.created_at_remote
        ||
        null
            ,
            
        failure_reason: data.failure_reason
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await tasks.setKnowledge_graph_item( data.knowledge_graph_item || null, {
            transaction,
        });
        
        await tasks.setExternal_integration( data.external_integration || null, {
            transaction,
        });
        
        await tasks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return tasks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const tasksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                external_task_key: item.external_task_key
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                task_status: item.task_status
            ||
            null
            ,
            
                created_at_remote: item.created_at_remote
            ||
            null
            ,
            
                failure_reason: item.failure_reason
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const tasks = await db.tasks.bulkCreate(tasksData, { transaction });

        // For each item created, replace relation files
        

        return tasks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const tasks = await db.tasks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.external_task_key !== undefined) updatePayload.external_task_key = data.external_task_key;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.task_status !== undefined) updatePayload.task_status = data.task_status;
        
        
        if (data.created_at_remote !== undefined) updatePayload.created_at_remote = data.created_at_remote;
        
        
        if (data.failure_reason !== undefined) updatePayload.failure_reason = data.failure_reason;
        
        
        updatePayload.updatedById = currentUser.id;

        await tasks.update(updatePayload, {transaction});

        
        
        if (data.knowledge_graph_item !== undefined) {
            await tasks.setKnowledge_graph_item(
              
              data.knowledge_graph_item,
              
              { transaction }
            );
        }
        
        if (data.external_integration !== undefined) {
            await tasks.setExternal_integration(
              
              data.external_integration,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await tasks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return tasks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const tasks = await db.tasks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of tasks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of tasks) {
                await record.destroy({transaction});
            }
        });


        return tasks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const tasks = await db.tasks.findByPk(id, options);

        await tasks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await tasks.destroy({
            transaction
        });

        return tasks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const tasks = await db.tasks.findOne(
            { where },
            { transaction },
        );

        if (!tasks) {
            return tasks;
        }

        const output = tasks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.knowledge_graph_item = await tasks.getKnowledge_graph_item({
            transaction
        });
        
        
        output.external_integration = await tasks.getExternal_integration({
            transaction
        });
        
        
        output.organizations = await tasks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.knowledge_graph_items,
        as: 'knowledge_graph_item',
        
        where: filter.knowledge_graph_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.knowledge_graph_item.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.knowledge_graph_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.external_integrations,
        as: 'external_integration',
        
        where: filter.external_integration ? {
          [Op.or]: [
            { id: { [Op.in]: filter.external_integration.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.external_integration.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.external_task_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tasks',
                        'external_task_key',
                        filter.external_task_key,
                    ),
                };
            }
            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tasks',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tasks',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.failure_reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'tasks',
                        'failure_reason',
                        filter.failure_reason,
                    ),
                };
            }
            

            
            

            
            if (filter.created_at_remoteRange) {
                const [start, end] = filter.created_at_remoteRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_at_remote: {
                    ...where.created_at_remote,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_at_remote: {
                    ...where.created_at_remote,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.task_status) {
                where = {
                    ...where,
                task_status: filter.task_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.tasks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'tasks',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.tasks.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

